#!/bin/bash
# $1: args type could be 'ft' (function test) or 'st' (system test), or 'help' to get the command line help. By default: ft
function pgrep_live {
  pids=$(pgrep "$1");
  [ "$pids" ] || return;
  ps -o s= -o pid= $pids | sed -n 's/^[^ZT][[:space:]]\+//p';
}
cd `dirname $0`
ARGS=args.$1
[ -z "$1" ] && ARGS=args.ft
STARTED=`pgrep_live ADML`
[ -n "$STARTED"  ] && { echo "Already started !"; echo "PID $STARTED" ; exit 1 ; }
0> launcher.trace
0> ADML.output
for file in `ls *.launcher.log 2>/dev/null`; do 0> $file; done
mkdir -p counters test-reports
rm -f counters/* test-reports/* *.csv
export LD_LIBRARY_PATH=$PWD/dynlibs
args=$(eval echo $(grep -v ^# $ARGS))
#ulimit -c unlimited
./ADML ${args} > ADML.output &
echo $! > .pid
echo "Done !"

