// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <iostream>
#include <string>
#include <unistd.h>
#include <stdlib.h>

#include <anna/time/Date.hpp>
#include <anna/time/functions.hpp>

using namespace anna;

void F_exit(const char *message) {
   std::cout << std::endl;
   std::cout << std::endl;
   std::cout << message << std::endl;
   std::cout << std::endl;
   std::cout << std::endl;
   exit(0);
}

int main(int argc, char** argv) {
   anna::time::functions::initialize();
   std::cout << std::endl;
   std::cout << std::endl;
   std::cout << "BASIC CONVERSIONS" << std::endl;

   // option
   if (!argv[1]) {
      std::string msg = "Usage: ";
      msg += argv[0];
      msg += " [-unix <unix timestamp>] [-ntp <ntp timestamp>] [-yyyymmddHHmmss <yyyymmddHHmmss (in the system timezone)>]";
      F_exit(msg.c_str());
   }

   std::string option = argv[1];

   if (option != "-unix" && option != "-ntp" && option != "-yyyymmddHHmmss") F_exit("Only -unix/-ntp/-yyyymmddHHmmss options supported !");

   // value
   if (!argv[2]) {
      F_exit("Missing value parameter !");
   }

   std::string value = argv[2];
   // CONVERSION
   anna::time::Date aux;

   if (option == "-unix") {
      aux.storeUnix(atoi(value.c_str()));
   } else if (option == "-ntp") {
      aux.storeNtp(atoi(value.c_str()));
   } else if (option == "-yyyymmddHHmmss") {
      aux.store(value);
   }

   std::cout << aux.asString() << std::endl;
   F_exit("The End !");
}

