// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef timex_ArithmeticHTTPServer_Application_hpp
#define timex_ArithmeticHTTPServer_Application_hpp

#include <anna/comm/Application.hpp>
#include <anna/comm/Communicator.hpp>
#include <anna/comm/ReceiverFactoryImpl.hpp>

#include <anna/timex/Engine.hpp>

#include "Acceptor.hpp"
#include "Reactor.hpp"

namespace anna {
   namespace comm {
      class ServerSocket;
      class IndexedDelivery;
   }
}

namespace test {

namespace http4comm {

class Context;

using namespace anna;

class Application : public comm::Application {
public:
   Application ();
  
   comm::IndexedDelivery* getService () throw () { return a_service; }
   http4comm::Context* getContext () throw () { return a_context; }
      
private:
   comm::Communicator* a_communicator;
   anna::timex::Engine a_timeController;
   http4comm::Context* a_context;

   comm::ReceiverFactoryImpl <Acceptor> a_acceptorFactory;
   comm::ReceiverFactoryImpl <Reactor> a_reactorFactory;
   comm::ServerSocket* a_serverSocket;
   comm::IndexedDelivery* a_service;

   void initialize () throw (RuntimeException);
   void run () throw (RuntimeException);
};

}
}

#endif

