// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_TransportFactoryImpl_hpp
#define anna_comm_TransportFactoryImpl_hpp

#include <anna/core/util/Recycler.hpp>

#include <anna/comm/TransportFactory.hpp>

namespace anna {

namespace comm {

class Transport;

/**
  Transport factory implementation
*/
template <typename T> class TransportFactoryImpl  : public TransportFactory {
public:
  /**
     Constructor.
  */
  TransportFactoryImpl() : TransportFactory(T::className()) {;}

private:
  Recycler <T> a_transports;

  Transport* create() throw() {
    Transport* result = static_cast <Transport*>(a_transports.create());
    int overQuotaSize;

    if((overQuotaSize = TransportFactory::getOverQuotaSize()) != 0)
      result->setOverQuotaSize(overQuotaSize);

    return result;
  }
  void release(Transport* transport) throw() { a_transports.release(static_cast <T*>(transport)); }
};

}
}

#endif

