// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_helpers_tme_defines_hpp
#define anna_diameter_helpers_tme_defines_hpp


// Local
#include <anna/diameter/helpers/defines.hpp>

// STL
#include <string>

// TME
#include <anna/diameter/helpers/tme/codectypes/codectypes.hpp>


/** Contextualized definitions (avp id) */
#define anna_diameter_helpers_define_avp(avpname,code)  anna_diameter_helpers_define_avp_in_context(avpname,code,tme)

/** Contextualized definitions (avp id and values) */
#define anna_diameter_helpers_define_avp_with_values(avpname,code)  anna_diameter_helpers_define_avp_with_values_in_context(avpname,code,tme)


namespace anna {

namespace diameter {

namespace helpers {

namespace tme {


/**
* Avps
*/
anna_diameter_helpers_define_avp(CS_Additional_Calling_Party_Number, 1);
anna_diameter_helpers_define_avp(CS_Announcement, 2);
anna_diameter_helpers_define_avp(CS_Announcement_Code, 3);
anna_diameter_helpers_define_avp(CS_Announcement_Data, 4);
anna_diameter_helpers_define_avp_with_values(CS_Announcement_Data_Type, 5) {
  enum v_ {
    Integer32 = 1,
    ISDNNumber = 2,
    Time = 3
  };
};

anna_diameter_helpers_define_avp(CS_Announcement_Data_Value, 6);
anna_diameter_helpers_define_avp(CS_Bearer_Capability, 7);
anna_diameter_helpers_define_avp(CS_Call_Reference_Number, 8);
anna_diameter_helpers_define_avp(CS_Called_Party_Number, 9);
anna_diameter_helpers_define_avp(CS_Calling_Partys_Category, 10);
anna_diameter_helpers_define_avp(CS_Calling_Party_Number, 11);
anna_diameter_helpers_define_avp_with_values(CS_Event_Type_BCSM, 12) {
  enum v_ {
    collectedInfo = 2,
    analyzedInformation = 3,
    routeSelectFailure = 4,
    oCalledPartyBusy = 5,
    oNoAnswer = 6,
    oAnswer = 7,
    oDisconnect = 9,
    oAbandon = 10,
    termAttemptAuthorized = 12,
    tBusy = 13,
    tNoAnswer = 14,
    tAnswer = 15,
    tDisconnect = 17,
    tAbandon = 18
  };
};

anna_diameter_helpers_define_avp_with_values(CS_First_Call_Indication, 13) {
  enum v_ {
    FIRST_CALL_FALSE = 0,
    FIRST_CALL_TRUE = 1
  };
};

anna_diameter_helpers_define_avp(CS_Free_Format_Data, 14);
anna_diameter_helpers_define_avp(CS_Furnish_Charging_Information, 15);
anna_diameter_helpers_define_avp(CS_High_Layer_Compatibility, 16);
anna_diameter_helpers_define_avp(CS_Information, 17);
anna_diameter_helpers_define_avp(CS_Location_Information, 18);
anna_diameter_helpers_define_avp(CS_MSC_Address, 19);
anna_diameter_helpers_define_avp(CS_Original_Called_Party_ID, 20);
anna_diameter_helpers_define_avp(CS_Originating_Location_Number, 21);
anna_diameter_helpers_define_avp(CS_Party_To_Charge, 22);
anna_diameter_helpers_define_avp(CS_Redirecting_Party_Number, 23);
anna_diameter_helpers_define_avp(CS_Redirection_Information, 24);
anna_diameter_helpers_define_avp(CS_Release_Cause_Code, 25);
anna_diameter_helpers_define_avp(CS_Rerouting_Number, 26);
anna_diameter_helpers_define_avp(CS_Service_Key, 27);
anna_diameter_helpers_define_avp(CS_Terminating_VLR_Number, 28);
anna_diameter_helpers_define_avp(CS_Warning_Period, 29);
anna_diameter_helpers_define_avp(CS_Accumulated_Time, 30);
anna_diameter_helpers_define_avp_with_values(CS_Announcement_Logic, 31) {
  enum v_ {
    NOT_TO_BE_PLAYED = 0,
    PLAYED_TO_CALLING_PARTY = 1,
    PLAYED_TO_CALLED_PARTY = 2,
    PLAYED_TO_BOTH_PARTIES = 3
  };
};

anna_diameter_helpers_define_avp_with_values(CS_Announcement_Type, 32) {
  enum v_ {
    IMMEDIATE_ANNOUNCEMENT = 0,
    MIDCALL_ANNOUNCEMENT = 1,
    ENDCALL_ANNOUNCEMENT = 2
  };
};

anna_diameter_helpers_define_avp(CS_Balance_TopUp_Data, 33);
anna_diameter_helpers_define_avp(CS_Call_SetUp_Result_Code, 34);
anna_diameter_helpers_define_avp(CS_Customer_Data, 35);
anna_diameter_helpers_define_avp_with_values(CS_Dialogue_Handling, 36) {
  enum v_ {
    NORMAL = 0,
    OPTIMIZED = 1
  };
};

anna_diameter_helpers_define_avp(CS_ISUP_Release_Cause_Code, 37);
anna_diameter_helpers_define_avp(CS_Max_Call_Duration, 38);
anna_diameter_helpers_define_avp(CS_Result_Code, 39);
anna_diameter_helpers_define_avp(CS_Start_Of_Charging, 40);
anna_diameter_helpers_define_avp(CS_Teleservice_Code, 41);
anna_diameter_helpers_define_avp(CS_Traffic_Case, 42);
anna_diameter_helpers_define_avp(CS_AoC_Info, 43);
anna_diameter_helpers_define_avp(CS_AoC_Info_e1, 44);
anna_diameter_helpers_define_avp(CS_AoC_Info_e2, 45);
anna_diameter_helpers_define_avp(CS_AoC_Info_e3, 46);
anna_diameter_helpers_define_avp(CS_AoC_Info_e4, 47);
anna_diameter_helpers_define_avp(CS_AoC_Info_e5, 48);
anna_diameter_helpers_define_avp(CS_AoC_Info_e6, 49);
anna_diameter_helpers_define_avp(CS_AoC_Info_e7, 50);
anna_diameter_helpers_define_avp(CS_Called_Party_BCD_Number, 51);
anna_diameter_helpers_define_avp(CS_Conference_Id, 52);
anna_diameter_helpers_define_avp(CS_MultiParty_Call_Indication, 53);
anna_diameter_helpers_define_avp(CS_Network_Type, 54);
anna_diameter_helpers_define_avp(CS_Service_Id, 55);
anna_diameter_helpers_define_avp(OCS_Account_Management_Op, 56);

// VIRTUAL PRIVATE NETWORK (VPN) SERVICE
anna_diameter_helpers_define_avp_with_values(VPN_Access_Type, 100) {
  enum v_ {
    Normal = 0,
    Registered = 1,
    Remote = 2
  };
};

anna_diameter_helpers_define_avp(VPN_Identifier, 101);
anna_diameter_helpers_define_avp(VPN_Information, 102);
anna_diameter_helpers_define_avp_with_values(VPN_Office_Zone_Indicator, 103) {
  enum v_ {
    Office_zone_call = 0,
    Non_Office_zone_call = 1
  };
};

anna_diameter_helpers_define_avp_with_values(VPN_On_Net_Indicator, 104) {
  enum v_ {
    On_net_call__Intragroup_Mobile_destination = 0,
    On_net_call__Intergroup_Mobile_destination = 1,
    On_net_call__Intragroup_Fixed_destination = 2,
    On_net_call__Intergroup_Fixed_destination = 3,
    Off_net_call = 4
  };
};

anna_diameter_helpers_define_avp(VPN_Public_Calling_Party_Number, 105);
anna_diameter_helpers_define_avp(VPN_Public_Redirecting_Party_Number, 106);
anna_diameter_helpers_define_avp_with_values(VPN_Soft_Hard_Treatment, 107) {
  enum v_ {
    Soft_global_and_partial_online_cost_controls = 0,
    Hard_global_online_cost_control = 1,
    Hard_voice_online_cost_control = 2,
    Hard_global_and_voice_online_cost_control = 3,
    Hard_global_online_cost_control_without_cut_off = 5,
    Hard_voice_online_cost_control_without_cut_off = 6,
    Hard_global_and_voice_online_cost_control_without_cut_off = 7
  };
};

// VIRTUAL CALLING CARD (VCC) SERVICE
anna_diameter_helpers_define_avp(VCC_Information, 151);
anna_diameter_helpers_define_avp(VCC_Number, 152);


/**
* Commands
*/


}
}
}
}


#undef anna_diameter_helpers_define_avp
#undef anna_diameter_helpers_define_avp_with_values

#endif

