// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_io_BinaryReader_hpp
#define anna_io_BinaryReader_hpp

#include <anna/core/DataBlock.hpp>
#include <anna/io/AbstractReader.hpp>

namespace anna {

namespace io {

/**
   Lector de ficheros de texto.
*/
class BinaryReader : public AbstractReader, public DataBlock {
public:
  /**
     Constructor.
     \param blockSize Tamao del bloque de lectura.
     \warning Si utilizamos este constructor debemos invocar al mtodo open antes
     de usar cualquier otro mtodo de la clase.
  */
  BinaryReader(const int blockSize);

  /**
     Constructor.
     \param filename Ruta completa del fichero a leer.
     \param blockSize Tamao del bloque de lectura.
  */
  BinaryReader(const char* filename, const int blockSize);

  /**
     Constructor.
     \param filename Ruta completa del fichero a leer.
     \param blockSize Tamao del bloque de lectura.
  */
  BinaryReader(const std::string& filename, const int blockSize);

  /**
     Destructor.
  */
  virtual ~BinaryReader();

  /**
     Devuelve el contenido de la lnea actual o NULL si se ha llegado al fin del fichero.
     \return El contenido de la lnea actual o NULL si se ha llegado al fin del fichero.
  */
  const DataBlock* fetch() throw(anna::RuntimeException);

private:
  const int a_blockSize;
};

}
}
#endif
