// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_xml_Compressor_hpp
#define anna_xml_Compressor_hpp

#include <anna/core/util/ZBlock.hpp>

namespace anna {

namespace xml {

class Document;

/**
   Comprime la informacin del rbol XML descrita por el nodo o el documento XML recibido como parmetro.

   \see Decompressor

   \warning Esta es una clase bastante pesada, por lo que casi-imprescindible reusar una misma instancia cada vez
   que se requiera comprimir un documento XML.
*/
class Compressor : ZBlock {
public:
  /**
   * Constructor
   */
  Compressor() {;}

  /**
   * Comprime la informacin del nodo recibido como parmetro. Para recuperar el original tendremos que
   * usar una instancia de Decompressor.
   *
   * \param node Nodo que contiene el rbol de nodos XML que queremos comprimir.
   * \return Un bloque de datos binario que contiene la informacin representada por el nodo.
   * */
  const DataBlock& apply(const Document& xmlDoc) throw(RuntimeException);

private:
  Compressor(const Compressor&);
};

}
}

#endif
