// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/config/defines.hpp>

#include <anna/comm/LargeBinaryCodec.hpp>
#include <anna/comm/functions.hpp>

using namespace std;
using namespace anna;

void comm::LargeBinaryCodec::decode(const DataBlock& dataBlock)
throw(RuntimeException) {
  DataBlock* block;
  comm::Codec::decode(dataBlock);
  const char* data = a_dataBlock.getData();
  int size;
  reset();

  for(int pos = 0, maxpos = a_dataBlock.getSize(); pos < maxpos;) {
    if((pos + sizeof(int)) >= maxpos)
      throw RuntimeException("Iterator out of range", ANNA_FILE_LOCATION);

    size = comm::functions::decodeInteger(data + pos);

    if((pos + sizeof(int) + size) > maxpos)
      throw RuntimeException("Iterator out of range", ANNA_FILE_LOCATION);

    block = new DataBlock(true);
    *block = DataBlock(data + sizeof(int) + pos, size, false);
    a_blocks.push_back(block);
    pos += sizeof(int) + size;
  }
}

void comm::LargeBinaryCodec::reset()
throw() {
  for(iterator ii = a_blocks.begin(), maxii = a_blocks.end(); ii != maxii; ii ++)
    delete data(ii);

  a_blocks.clear();
}

comm::LargeBinaryCodec& comm::LargeBinaryCodec::operator += (const DataBlock & dataBlock)
throw(RuntimeException) {
  char size [sizeof(int)];
  a_dataBlock.append(functions::codeInteger(size, dataBlock.getSize()), sizeof(int));
  a_dataBlock += dataBlock;
  DataBlock* block = new DataBlock(true);
  *block = dataBlock;
  a_blocks.push_back(block);
  return *this;
}


