// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/config/defines.hpp>

#include <anna/comm/LiteTransport.hpp>
#include <anna/comm/Message.hpp>
#include <anna/comm/functions.hpp>

using namespace anna;

comm::TransportFactoryImpl <comm::LiteTransport> comm::LiteTransport::st_transportFactory;

comm::LiteTransport::LiteTransport() :
  comm::Transport() {
  setInputMessage(new Message());
}

comm::LiteTransport::~LiteTransport() {
  delete getInputMessage();
}

int comm::LiteTransport::calculeSize(const DataBlock& dataBlock)
throw(RuntimeException) {
  const char* buffer = dataBlock.getData();
  return (dataBlock.getSize() >= headerSize) ? functions::decodeShort(buffer) + headerSize : -1;
}

const comm::Message* comm::LiteTransport::decode(const DataBlock& message)
throw(RuntimeException) {
  const int totalSize = message.getSize();

  if(totalSize < headerSize)
    throw RuntimeException("Invalid message to decode", ANNA_FILE_LOCATION);

  const char* buffer = message.getData();
  const int bodySize = totalSize - headerSize;

  if(bodySize < 0)
    throw RuntimeException("Invalid message size to decode", ANNA_FILE_LOCATION);

  return getInputMessage()->setBody(buffer + headerSize, bodySize);
}

const DataBlock& comm::LiteTransport::code(comm::Message& message)
throw(RuntimeException) {
  char aux [sizeof(int)];
  const DataBlock& data = message.code();
  a_forCode.clear();
  a_forCode.append(functions::codeShort(aux, data.getSize()), headerSize);
  return a_forCode += data;
}

