// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/core/util/TextVariable.hpp>

using namespace std;
using namespace anna;

TextVariable::TextVariable(const char* name, const Type::_v type, const anna::String& expression) :
  Variable(name, type),
  a_expression(expression) {
}

const char* TextVariable::compose(DataBlock& buffer) const
throw(RuntimeException) {
  if(Variable::isNull() == true)
    throw RuntimeException(asString(), ANNA_FILE_LOCATION);

  switch(getType()) {
  case Variable::Type::String:
    buffer.allocate(a_expression.length() + anna_strlen(getStringValue()) + 1);
    sprintf((char*) buffer.getData(), a_expression.c_str(), getStringValue());
    break;
  case Variable::Type::Integer:
    buffer.allocate(a_expression.length() + 16);
    sprintf((char*) buffer.getData(), a_expression.c_str(), getIntegerValue());
    break;
  case Variable::Type::Integer64:
    buffer.allocate(a_expression.length() + 32);
    sprintf((char*) buffer.getData(), a_expression.c_str(), getInteger64Value());
    break;
  case Variable::Type::Float:
    buffer.allocate(a_expression.length() + 32);
    sprintf((char*) buffer.getData(), a_expression.c_str(), getFloatValue());
    break;
  default: break;
  }

  return buffer.getData();
}
